﻿Namespace PolymorphismExample1

    Class Employee
        Public Overridable Sub Work()
            Console.WriteLine("I am an employee.")
        End Sub
    End Class

    Class Manager
        Inherits Employee

        Public Overrides Sub Work()
            Console.WriteLine("I am a manager.")
        End Sub

        Public Sub Manage()
            Console.WriteLine("Managing ...")
        End Sub
    End Class

    Class Program

        Shared Sub Main(args As String())
            Dim employee As Employee
            employee = New Manager()
            Console.WriteLine(employee.GetType().ToString())
            employee.Work()
            Dim manager As Manager = DirectCast(employee, Manager)
            manager.Manage()

            Console.ReadKey()
        End Sub
    End Class
End Namespace
